package com.exquisiteapplicationsolutions.tis.activities;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.exquisiteapplicationsolutions.tis.R;


public class AboutActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_about);

        SharedPreferences prefs = getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sLoggedInUserCompany = prefs.getString("LoggedInUserCompany", "No Value");
        String sCurrentVersion = prefs.getString("TISVersion", "No Value");
        TextView tvVersion = (TextView) findViewById(R.id.tvVersion);
        String sVersionText = tvVersion.getText().toString();
        sVersionText = sVersionText.replace("RELNUM",sCurrentVersion);
        TextView tvOSVersion = (TextView) findViewById(R.id.tvOSVersion);
        String sOSVersionText = tvOSVersion.getText().toString();
        sOSVersionText = sOSVersionText.replace("OSVERSIONNUM",android.os.Build.VERSION.RELEASE);
        TextView tvDeviceName = (TextView) findViewById(R.id.tvDeviceName);
        String sDeviceNameText = tvDeviceName.getText().toString();
        sDeviceNameText = sDeviceNameText.replace("DEVICENAME",android.os.Build.MODEL);
        TextView tvDeviceManufactrer = (TextView) findViewById(R.id.tvDeviceManufacturer);
        String sDeviceManufactrerText = tvDeviceManufactrer.getText().toString();
        sDeviceManufactrerText = sDeviceManufactrerText.replace("DEVICEMANUFACTURER",android.os.Build.MANUFACTURER);
        TextView tvDeviceSerial = (TextView) findViewById(R.id.tvDeviceSerial);
        String sDeviceSerialText = tvDeviceSerial.getText().toString();
        sDeviceSerialText = sDeviceSerialText.replace("SERIALNUM",android.os.Build.SERIAL);

        tvVersion.setText(sVersionText);
        tvOSVersion.setText(sOSVersionText);
        tvDeviceName.setText(sDeviceNameText);
        tvDeviceManufactrer.setText(sDeviceManufactrerText);
        tvDeviceSerial.setText(sDeviceSerialText);

        Button btnOK = (Button) findViewById(R.id.btnOK);
        btnOK.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
            }
        });

        TextView otvSupportNumber = (TextView) findViewById(R.id.tvSupportNumber);
        otvSupportNumber.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                dialPhone("8887748044");
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_about, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private void dialPhone(String sPhoneNumber) {
        Intent callIntent = new Intent(Intent.ACTION_CALL);
        callIntent.setData(Uri.parse("tel:" + sPhoneNumber));
        //textView.getText().toString().trim()));
        startActivity(callIntent );
    }

}
