package com.exquisiteapplicationsolutions.tis.activities;

import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.sqlite.SQLiteException;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.exquisiteapplicationsolutions.tis.DBLogs;
import com.exquisiteapplicationsolutions.tis.DateConvertClass;
import com.exquisiteapplicationsolutions.tis.R;
import com.exquisiteapplicationsolutions.tis.TISDBHelper;
import com.exquisiteapplicationsolutions.tis.syncClasses.SyncTasks;
import com.exquisiteapplicationsolutions.tis.syncClasses.TISCommon;
import com.exquisiteapplicationsolutions.tis.util.BitmapScaler;
import com.exquisiteapplicationsolutions.tis.webServices.SyncJson;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;


public class DVIRActivity extends AppCompatActivity {

    private static final String sDBName = "TIS.db";
    private static String sUserID = "";
    private static String DVIRNo = "";
    int REQUEST_IMAGE_CAPTURE = 1;
    private File storageDir = new File(Environment.getExternalStorageDirectory() + "/tis");
    private File photoFile = null;
    private static final int iVersionVal = 7;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_dvir);

        SharedPreferences prefs = getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sLoggedInUserCompany = prefs.getString("LoggedInUserCompany", "No Value");
        sUserID = prefs.getString("UserID", "No Value");

        String sCurrentVersion = prefs.getString("TISVersion", "No Value");
        TextView otvCopyright = (TextView) findViewById(R.id.tvCopyright);
        String sVersionText = otvCopyright.getText().toString();
        // need to replace the %RELNUM% with the actual rel version
        sVersionText = sVersionText.replace("RELNUM", sCurrentVersion);
        otvCopyright.setText(sVersionText);

        TextView otvUserName = (TextView) findViewById(R.id.tvUserName);
        otvUserName.setText(sLoggedInUserCompany.substring(0,sLoggedInUserCompany.indexOf('-')));

        Button btnDVIREntry = (Button) findViewById(R.id.btnDVIREntry);
        btnDVIREntry.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                DVIREntry();
            }
        });

        Button btnDVIRReport = (Button) findViewById(R.id.btnDVIRReports);
        btnDVIRReport.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                DVIRREports();
            }
        });

        Button btnDVIRImageCapture = (Button) findViewById(R.id.btnDVIRImageCapture);
        btnDVIRImageCapture.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                DVIRImageCapture();
            }
        });

        //Check to see if a DVIR is open.  That will determine which buttons are active
        if (checkForOpenDVIR()) {
            //There is an open DVIR
            btnDVIREntry.setEnabled(false);
        } else {
            btnDVIRImageCapture.setEnabled(false);
        }

        //Check to see if a DVIR is open.  That will determine which buttons are active
        if (checkForOpenDVIR()) {
            //There is an open DVIR
            btnDVIREntry.setEnabled(false);
            btnDVIREntry.setBackgroundColor(getResources().getColor(R.color.TISPurpleDisabled));
            btnDVIRImageCapture.setBackgroundColor(getResources().getColor(R.color.TISPurple));
        } else {
            btnDVIRImageCapture.setEnabled(false);
            btnDVIRImageCapture.setBackgroundColor(getResources().getColor(R.color.TISPurpleDisabled));
            btnDVIREntry.setBackgroundColor(getResources().getColor(R.color.TISPurple));
            //Only update the fields for the various dvir tables if there is not an open dvir
            //Have not fully tested what will happen if the fields are modified when there is an
            //open dvir.
            downloadDVIRItems();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_dvirselect, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }
        if (id == R.id.action_logout) {
            finish();
            Intent i = new Intent(getApplicationContext(), TISActivity.class);
            startActivity(i);
            return true;
        }
        if (id == R.id.action_icon_meanings) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "IconMeanings");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_icon_meanings) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "IconMeanings");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_help) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "DVIRActivity");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_about) {
            Intent i = new Intent(getApplicationContext(), AboutActivity.class);
            startActivity(i);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private void DVIREntry() {
        Intent checkListIntent = new Intent(this, DVIREntryActivity.class);
        checkListIntent.putExtra("CheckListNumber", 1);
        startActivity(checkListIntent);
        //Leaving this here just in case we need to have more than one DVIR form
        /*Intent i = new Intent(getApplicationContext(), DVIRSelectActivity.class);
        startActivity(i);*/
    }

    private void DVIRREports() {
        Intent i = new Intent(getApplicationContext(), DVIRReportsActivity.class);
        startActivity(i);
    }

    private void DVIRImageCapture() {
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        if (makeAndClearPictureDirectorys(storageDir)) {
            photoFile = null;
            String sImageName = "dvirTemp";
            File storageDirTemp = new File(storageDir, "temp");
            photoFile = new File(storageDirTemp, sImageName);
            if (photoFile != null) {
                takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT,
                        Uri.fromFile(photoFile));
                startActivityForResult(takePictureIntent, REQUEST_IMAGE_CAPTURE);
            }
        }
    }

    private boolean checkForOpenDVIR() {
        Boolean bRtnValue = false;
        Context oContext = getApplicationContext();
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            String sSQL = ("select DVIRNo from DVIREntered where CompletedDVIR = 'NO'");
            oDB.createDataBase();
            oDB.openDataBase();
            ArrayList<String> sDVIRRecordsList = oDB.getList(sSQL, null);
            if (!sDVIRRecordsList.isEmpty()) {
                DVIRNo = sDVIRRecordsList.get(0);
                bRtnValue = true;
            }
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        } catch (SQLiteException ex) {
        DBLogs.insert("Sqlite Error: " + ex.toString(),
                "DVIRActivity.downloadDVRItems", oContext,
                sDBName, iVersionVal);
        } finally {
            oDB.close();
        }
        return bRtnValue;
    }

    private boolean makeAndClearPictureDirectorys(File fStorageDir) {
        File fStorageDirTemp = new File(fStorageDir, "temp");
        if (!fStorageDirTemp.exists()) {
            //mkdirs makes the directory and parent directory if it does not exist
            fStorageDirTemp.mkdirs();
        }
        //Now see if there is anything in the temp dir and delete.  There should never be anythin
        //in the temp directory since it will hold the full size file until it is shrunk
        if (fStorageDirTemp.isDirectory()) {
            File[] files = fStorageDirTemp.listFiles();
            for (File file : files)
            {
                if (!file.delete())
                {
                    System.out.println("Failed to delete " + file);
                }
            }
        }
        return fStorageDirTemp.isDirectory();
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        //resultCode of 0 means no picture taken. resultCode of -1 means picture taken
        if (requestCode == REQUEST_IMAGE_CAPTURE && resultCode == -1) {
            //At this point the picture has been captured and is ready for upload
            //We also want to decrease the file size for upload and storage on the server
            String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
            String sImageName = DVIRNo + "_" + timeStamp + ".jpg";
            String sImageFullPath = photoFile.toString();
            File picureTempFile = new File(sImageFullPath);
            try {
                BitmapScaler scaler = new BitmapScaler(picureTempFile, 400);
                Bitmap bmp = Bitmap.createBitmap(scaler.getScaled());
                OutputStream stream = new FileOutputStream(storageDir.toString() + "/" + sImageName);
                bmp.compress(Bitmap.CompressFormat.JPEG, 90, stream);
                picureTempFile.delete();
                //Need to delete the temp file here
            } catch (IOException ex) {
                //todo
            }
            // enter into sync table
            queueForSync(sImageName);
            sImageName = "";
        }
    }

    private void queueForSync(String sItemToSync) {
        // queue the message to be sent
        DateConvertClass oDateConvertClass = new DateConvertClass();
        oDateConvertClass.oContext = getApplicationContext();
        String sCurrentDateTime = oDateConvertClass.GMTTimestamp();
        SyncTasks syncTasks = new SyncTasks();
        syncTasks.oContext = getApplicationContext();
        syncTasks.sRecType = "Photo";
        syncTasks.sRecID = sItemToSync;
        syncTasks.sDateTime = sCurrentDateTime;
        syncTasks.sQueued = "0";
        syncTasks.sDateTimeQueued = "";
        syncTasks.sCompleted = "0";
        syncTasks.sDateTimeCompleted = "";
        syncTasks.write();
    }

    //This will download the table values needed for DVIRs if the table values have changed.
    //This is accomplished by creating a hash of the field values in the phone data base and
    //comparing them to the hash of field values in the server database.
    private void downloadDVIRItems() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                Context oContext = getApplicationContext();
                if (TISCommon.isOnline(oContext)) {
                    //Creating the hashes of all the data tables that will be passed to the
                    //webservice to see if we need a download.  This way we only download changes
                    JSONObject oTableHashes = new JSONObject();
                    TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
                    //Open a database connection and get all of the hashes
                    try {
                        oDB.createDataBase();
                        oDB.openDataBase();
                        try {
                            oTableHashes.put("dvir_codes", createMD5HashFromTable("DVIRCodes", oDB));
                            oTableHashes.put("dvir_assigned_fields", createMD5HashFromTable("DVIRAssignedFields", oDB));
                            oTableHashes.put("dvir_fields", createMD5HashFromTable("DVIRFields", oDB));
                            oTableHashes.put("dvir_form_images", createMD5HashFromTable("DVIRFormImages", oDB));
                            oTableHashes.put("dvir_forms", createMD5HashFromTable("DVIRForms", oDB));
                            oTableHashes.put("dvir_field_groups", createMD5HashFromTable("DVIRFieldGroups", oDB));
                        } catch (JSONException ex) {
                            DBLogs.insert("JSON Error: " + ex.toString(),
                                    "DVIRActivit.downloadDVIRItems", oContext,
                                    sDBName, iVersionVal);
                        }
                    } catch (IOException ioe) {
                        throw new Error("Unable to create database");
                    } catch (SQLiteException ex) {
                        DBLogs.insert("Sqlite Error: " + ex.toString(),
                                "DVIRActivity.downloadDVRItems", oContext,
                                sDBName, iVersionVal);
                    } finally {
                        oDB.close();
                    }
                    SyncJson oDVIRSelection = new SyncJson();
                    oDVIRSelection.oContext = oContext;
                    //Send the tables and hash to the servers
                    oDVIRSelection.sendString = oTableHashes.toString();
                    oDVIRSelection.webserviceName = "getDVIRSelectionData.php";
                    String sResponse = oDVIRSelection.SyncData();
                    //Check to make sure something reasonable was returned
                    if (sResponse.length() > 10) {
                        try {
                            oDB.openDataBase();
                            try {
                                //Parse the return.  This is a json object that consists of
                                //the table name and the key value pair array of field name / field value
                                JSONObject oDVIRObject = new JSONObject(sResponse);
                                for (int i = 0; i < oDVIRObject.names().length(); i++) {
                                    String sTable = oDVIRObject.names().getString(i);
                                    updateTable(sTable, oDVIRObject.getJSONArray(sTable), oDB);
                                }
                            } catch (JSONException ex) {
                                DBLogs.insert("JSON Error: " + ex.toString(),
                                        "DVIRActivit.downloadDVIRItems", oContext,
                                        sDBName, iVersionVal);
                            }
                        } catch (SQLiteException ex) {
                            DBLogs.insert("Sqlite Error: " + ex.toString(),
                                    "DVIRActivity.downloadDVRItems", oContext,
                                    sDBName, iVersionVal);
                        } finally {
                            oDB.close();
                        }
                    }
                }
            }
        }).start();
    }

    //Create the MD5 hash that will be used to see if the table data is the same on the server
    private String createMD5HashFromTable(String sTable, TISDBHelper oDB) {
        String sHash = "";
        Context oContext = getApplicationContext();
        String sSQL = ("select * from " + sTable);
        ArrayList<ArrayList<String>> tableArray = oDB.selectRecordsFromDBList(sSQL, null);
        JSONArray oTableArray = new JSONArray(tableArray);
        sHash = createJsonHash(oTableArray.toString());
        return sHash;
    }

    private String createJsonHash(String sInput) {
        String sHash = "";
        try {
            MessageDigest m = MessageDigest.getInstance("MD5");
            byte[] hashedBytes = m.digest(sInput.getBytes("UTF-8"));
            sHash = convertByteArrayToHexString(hashedBytes);
        } catch (NoSuchAlgorithmException ex) {
            DBLogs.insert("MD5 Error: " + ex.toString(),
                    "DVIRActivit.createJsonHash", getApplicationContext(),
                    sDBName, iVersionVal);
        } catch (UnsupportedEncodingException ex) {
            DBLogs.insert("MD5 Encoding Error: " + ex.toString(),
                    "DVIRActivit.createJsonHash", getApplicationContext(),
                    sDBName, iVersionVal);
        }
        return sHash;
    }

    private String convertByteArrayToHexString(byte[] arrayBytes) {
        StringBuffer stringBuffer = new StringBuffer();
        for (int i = 0; i < arrayBytes.length; i++) {
            stringBuffer.append(Integer.toString((arrayBytes[i] & 0xff) + 0x100, 16)
                    .substring(1));
        }
        return stringBuffer.toString();
    }

    //If table is returned then it does not match the server table so we need to delete
    //the current table data and insert the returned values
    private void updateTable(String sTable, JSONArray oTableValues, TISDBHelper oDB) {
        switch (sTable) {
            case "dvir_fields":
                //Delete the table contents
                oDB.deleteAllRecords("DVIRFields");
                for (int iCounter = 0; iCounter < oTableValues.length(); iCounter++) {
                    ContentValues oValues = new ContentValues();
                    try {
                        JSONObject oDVIRItem = oTableValues.getJSONObject(iCounter);
                        oValues.put("_id", oDVIRItem.getString("id"));
                        oValues.put("Title", oDVIRItem.getString("item_name"));
                        oDB.insertRecordsInDB("DVIRFields", null, oValues);
                    } catch (JSONException ex) {
                        DBLogs.insert("JSON Error: " + sTable + " " + ex.toString(),
                                "DVIRActivity.updateTable", getApplicationContext(),
                                sDBName, iVersionVal);
                    }
                }
                break;
            case "dvir_codes":
                oDB.deleteAllRecords("DVIRCodes");
                for (int iCounter = 0; iCounter < oTableValues.length(); iCounter++) {
                    ContentValues oValues = new ContentValues();
                    try {
                        JSONObject oDVIRItem = oTableValues.getJSONObject(iCounter);
                        oValues.put("_id", oDVIRItem.getString("id"));
                        oValues.put("Code", oDVIRItem.getString("code"));
                        oValues.put("Name", oDVIRItem.getString("name"));
                        oValues.put("sort_order", oDVIRItem.getString("sort_order"));
                        oDB.insertRecordsInDB("DVIRCodes", null, oValues);
                    } catch (JSONException ex) {
                        DBLogs.insert("JSON Error: " + sTable + " " + ex.toString(),
                                "DVIRActivity.updateTable", getApplicationContext(),
                                sDBName, iVersionVal);
                    }
                }
                break;
            case "dvir_assigned_fields":
                oDB.deleteAllRecords("DVIRAssignedFields");
                for (int iCounter = 0; iCounter < oTableValues.length(); iCounter++) {
                    ContentValues oValues = new ContentValues();
                    try {
                        JSONObject oDVIRItem = oTableValues.getJSONObject(iCounter);
                        oValues.put("_id", oDVIRItem.getString("id"));
                        oValues.put("DVIRNo", oDVIRItem.getString("dvir_form_id"));
                        oValues.put("FieldID", oDVIRItem.getString("dvir_field_id"));
                        oValues.put("FieldGroupID", oDVIRItem.getString("dvir_field_group_id"));
                        oValues.put("SortOrder", oDVIRItem.getString("sort_order"));
                        oDB.insertRecordsInDB("DVIRAssignedFields", null, oValues);
                    } catch (JSONException ex) {
                        DBLogs.insert("JSON Error: " + sTable + " " + ex.toString(),
                                "DVIRActivity.updateTable", getApplicationContext(),
                                sDBName, iVersionVal);
                    }
                }
                break;
            case "dvir_form_images":
                oDB.deleteAllRecords("DVIRFormImages");
                for (int iCounter = 0; iCounter < oTableValues.length(); iCounter++) {
                    ContentValues oValues = new ContentValues();
                    try {
                        JSONObject oDVIRItem = oTableValues.getJSONObject(iCounter);
                        oValues.put("_id", oDVIRItem.getString("id"));
                        oValues.put("DVIRID", oDVIRItem.getString("dvir_id"));
                        oValues.put("ImageName", oDVIRItem.getString("image_name"));
                        oValues.put("ImageNumber", oDVIRItem.getString("image_number"));
                        oDB.insertRecordsInDB("DVIRFormImages", null, oValues);
                    } catch (JSONException ex) {
                        DBLogs.insert("JSON Error: " + sTable + " " + ex.toString(),
                                "DVIRActivity.updateTable", getApplicationContext(),
                                sDBName, iVersionVal);
                    }
                }
                break;
            case "dvir_forms":
                oDB.deleteAllRecords("DVIRForms");
                for (int iCounter = 0; iCounter < oTableValues.length(); iCounter++) {
                    ContentValues oValues = new ContentValues();
                    try {
                        JSONObject oDVIRItem = oTableValues.getJSONObject(iCounter);
                        oValues.put("Active", oDVIRItem.getString("active"));
                        oValues.put("_id", oDVIRItem.getString("id"));
                        oValues.put("DVIRNo", oDVIRItem.getString("dvir_number"));
                        oValues.put("Code", oDVIRItem.getString("code"));
                        oValues.put("Title", oDVIRItem.getString("title"));
                        oDB.insertRecordsInDB("DVIRForms", null, oValues);
                    } catch (JSONException ex) {
                        DBLogs.insert("JSON Error: " + sTable + " " + ex.toString(),
                                "DVIRActivity.updateTable", getApplicationContext(),
                                sDBName, iVersionVal);
                    }
                }
                break;
            case "dvir_field_groups":
                oDB.deleteAllRecords("DVIRFieldGroups");
                for (int iCounter = 0; iCounter < oTableValues.length(); iCounter++) {
                    ContentValues oValues = new ContentValues();
                    try {
                        JSONObject oDVIRItem = oTableValues.getJSONObject(iCounter);
                        oValues.put("_id", oDVIRItem.getString("id"));
                        oValues.put("Name", oDVIRItem.getString("name"));
                        oValues.put("SortOrder", oDVIRItem.getString("sort_order"));
                        oDB.insertRecordsInDB("DVIRFieldGroups", null, oValues);
                    } catch (JSONException ex) {
                        DBLogs.insert("JSON Error: " + sTable + " " + ex.toString(),
                                "DVIRActivity.updateTable", getApplicationContext(),
                                sDBName, iVersionVal);
                    }
                }
                break;
        }

    }
}


