package com.exquisiteapplicationsolutions.tis.activities;

import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.TextView;

import com.exquisiteapplicationsolutions.tis.R;
import com.exquisiteapplicationsolutions.tis.TISDBHelper;

import java.io.IOException;


public class UserPolicy extends AppCompatActivity {
    /********************************************************************************/
	/* Define Global Variables */
    /********************************************************************************/
    private static final String sDBName = "TIS.db";
    static int iVersionVal = 7;
    private static String sUserID;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user_policy);

        sUserID = getIntent().getExtras().getString("UserID");

        SharedPreferences prefs = getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sLoggedInUserCompany = prefs.getString("LoggedInUserCompany", "No Value");
        TextView otvUserName = (TextView) findViewById(R.id.tvUserName);
        otvUserName.setText(sLoggedInUserCompany.substring(0,sLoggedInUserCompany.indexOf('-')));

        WebView wvPolicy = (WebView) findViewById(R.id.wvPolicy);
        wvPolicy.loadUrl("file:///android_asset/TISEULA.htm");

        Button btnAccept = (Button) findViewById(R.id.btnAccept);
        btnAccept.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                updateAcceptanceOfPolicy();
                finish();
                Intent i = new Intent(getApplicationContext(), StartupActivity.class);
                startActivity(i);
                Intent i1 = new Intent(getApplicationContext(), HelpActivity.class);
                i1.putExtra("ScreenID", "IconMeanings");
                startActivity(i1);
            }
        });

        Button btnDecline = (Button) findViewById(R.id.btnDecline);
        btnDecline.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
                Intent i = new Intent(getApplicationContext(), TISActivity.class);
                startActivity(i);
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_user_policy, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }
        if (id == R.id.action_logout) {
            finish();
            Intent i = new Intent(getApplicationContext(), TISActivity.class);
            startActivity(i);
            return true;
        }
        if (id == R.id.action_help) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID","UserPolicy");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_about) {
            Intent i = new Intent(getApplicationContext(), AboutActivity.class);
            startActivity(i);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private void updateAcceptanceOfPolicy() {
        ContentValues oValues = new ContentValues();
        oValues.put("AcceptedUsagePolicy", "1");
        TISDBHelper oDB = new TISDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
            oDB.openDataBase();
            oDB.updateRecordsInDB("EmployeeMaster", "UserID = '"
                    + sUserID + "'", oValues);
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        } finally {
            oDB.close();
        }

    }
}
