package com.exquisiteapplicationsolutions.tis.webServices;

import android.content.Context;

import com.exquisiteapplicationsolutions.tis.DBLogs;
import com.exquisiteapplicationsolutions.tis.DBParameters;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.URL;

/**
 * Created by jnissley on 8/12/15.
 */
public class SyncJson {
    public Context oContext;
    public String webserviceName;
    public String sendString = null;  //This should be a json string but does not need to be
    private static final String sDBName = "TIS.db";
    private static final int iVersionVal = 7;
    private String message;

    /*
    This will send JSON text or really any text to the web service on the server
     */
    public String SyncData() {
        String oReturnData = "Failed";
        message = sendString;
        DBParameters oDBParameters = new DBParameters();
        String serverURL = oDBParameters.readParameter(
                "REST_BASE_URL", oContext, sDBName,
                iVersionVal);
        serverURL += webserviceName;
        try {
            URL url = new URL(serverURL);
            HttpURLConnection con = (HttpURLConnection) url.openConnection();

            try {
                con.setRequestMethod("POST");
                con.setDoOutput(true);
                con.setDoInput(true);
                con.setInstanceFollowRedirects(false);
                con.setRequestProperty("Content-Type", "application/json; charset=UTF-8");
                con.setRequestProperty("X-Requested-With", "XMLHttpRequest");
                OutputStream out = new BufferedOutputStream(con.getOutputStream());
                out.write(message.getBytes("UTF-8"));
                out.flush();
                out.close();
                if (con.getResponseCode() == 200) {
                    BufferedReader reader = new BufferedReader(new InputStreamReader(con.getInputStream()));
                    String sLine = null;
                    StringBuilder sb = new StringBuilder();
                    // Read Server Response
                    while ((sLine = reader.readLine()) != null) {
                        // Append server response in string
                        sb.append(sLine + "");
                    }
                    oReturnData = sb.toString();
                } else {
                    //Bad response from server
                    DBLogs.insert("Connection to web server failed with code " + con.getResponseCode(),
                            "SyncJson Class",
                            oContext, sDBName, iVersionVal);
                    try {
                        JSONObject oResponseValues = new JSONObject();
                        oResponseValues.put("response_code", con.getResponseCode());
                        oResponseValues.put("response_text", con.getResponseMessage());
                        JSONObject oResponse = new JSONObject();
                        oResponse.put("response", oResponseValues);
                        oReturnData = oReturnData.toString();
                    } catch (JSONException ex) {
                        oReturnData = "Failed";
                        DBLogs.insert("Unable to create json response code " + ex.getMessage(),
                                "SyncJson Class",
                                oContext, sDBName, iVersionVal);
                    }
                }
            } catch (ProtocolException pex) {
                oReturnData = "Failed";
                DBLogs.insert("Protocol Exception " + pex.getMessage(),
                        "SyncJson Class",
                        oContext, sDBName, iVersionVal);
            }
        } catch (IOException ioex) {
            DBLogs.insert("IO Exception " + ioex.getMessage(),
                    "SyncJson Class",
                    oContext, sDBName, iVersionVal);
        }
        return oReturnData;
    }

    private String isJSONValid(String sValue) {
        String bRTNValue = null;
        try {
            new JSONObject(sValue);
            bRTNValue = "Object";
        } catch (JSONException ex) {
            try {
                new JSONArray(sValue);
                bRTNValue = "Array";
            } catch (JSONException ex1) {
                bRTNValue = "Invalid";
            }
        }
        return bRTNValue;
    }
}
